routes/web.php
<?php

use App\Http\Controllers\MovieController;
// use App\Http\Controllers\admin\MovieController;
use App\Http\Controllers\admin\ViewMovie;
use App\Http\Controllers\BookingController;
use App\Http\Controllers\ViewController;
use App\Models\Movie;
use App\Http\Controllers\BookingControllertrial;
use Database\Seeders\BookingSeeder;
use Illuminate\Routing\RouteGroup;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::Get('dashboard',[MovieController::class,'dashboard'])->name('dashboard')->middleware(['auth']);


require __DIR__.'/auth.php';


Route::middleware(['auth','is_user'])->group(function () {
    Route::get('/dashboard/book', [BookingController::class,'getTickets'])->name('book');
    Route::post('/dashboard/book', [BookingController::class,'bookTickets'])->name('dashboard/cancel');
    Route::get('/dashboard/cancel',[BookingController::class,'getUserTickets'])->name('cancel');

    Route::post('/dashboard/cancel',[BookingController::class,'cancelTickets'])->name('dashboard/cancel');
    Route::get('/dashboard/purchase',[BookingController::class,'purchaseHistory'])->name('purchase');   
});

Route::middleware(['auth', 'is_admin'])->group(function () {
    Route::get('dashboard/addmovie', function () {
        return view('addmovie');
    })->name('addmovie');
    Route::post('dashboard/addmovie', [MovieController::class,'addMovie']);
    Route::get('dashboard/viewmovie', [MovieController::class,'viewMovie'])->name('viewmovie');
    Route::get('dashboard/editmovie', [MovieController::class,'movieOptionEdit'])->name('editmovie');
    Route::get('dashboard/editmovie/{id}', [MovieController::class,'ajaxComplete']);
    Route::post('dashboard/editmovie', [MovieController::class,'editMovie']);
    Route::get('dashboard/mail',[MovieController::class,'mail']);
});

app/Models/Booking.php
<?php

namespace App\Models;

use GuzzleHttp\Psr7\Request;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class Booking extends Model
{
    use HasFactory;
    protected $table = 'booking';

    protected $fillable = [
        'movie_id',
        'user_id',
        'seats_booked',
    ];

    public function booking()
    {
        return $this->morphTo();
    }

    public function getBookingDateAttribute(){
        return date('d-M-Y',strtotime($this->attributes['created_at']));
    }


}

app/Models/Movie.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Movie extends Model
{
    use HasFactory;
    protected $table = 'movie';

    protected $fillable = [
        'title',
        'movie_description',
        'available_seats',
        'show_time'
    ];

    public function Booking(){
        return $this->morphMany(Booking::class,'booking');
    }

    public function getShowDateAttribute(){
        return date('Y-M-d',strtotime($this->attributes['show_time']));
    }

    public function getShowAttribute(){
        return date('H-i',strtotime($this->attributes['show_time']));
    }

}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/addmovie.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Add Movie') }}
        </h2>
    </x-slot>

    @if(Session::has('errors'))
    <div class="pl-4 border-red-600 bg-red-200 ">
        Whoops! Please Check your fields.
    </div>
    @endif
    <div class="py-4 ">
        <div class="flex items-center w-full ">
            <div class="w-full bg-green-100 rounded shadow-lg p-8 m-14 md:max-w-md md:mx-auto">
                <div class="block w-full  text-grey-darkest mb-6">
                    <form class="mb-4" method="post" action="{{url('/dashboard/addmovie')}}">
                        {{csrf_field()}}
                        <div class="flex flex-col mb-4">
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest" for="movie_title">Movie Title</label>
                            <input class="border py-2 px-3 text-grey-darkest" type="text"  name="movie_title" id="movie_title">
                            <span class="text-sm text-red-500">{{$errors->book->first('movie_title')}}</span>
                        </div>
                        <div class="flex flex-col mb-4">
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest" for="movie_description">Description</label>
                            <input class="border py-2 px-3 text-grey-darkest" type="text" name="movie_description" id="movie_description">
                            <span class="text-sm text-red-500">{{$errors->book->first('movie_description')}}</span>
                        </div>
                        <div class="flex flex-col mb-4">
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest" for="show_time">Show Time</label>
                            <input class="border py-2 px-3 text-grey-darkest" type="datetime-local" name="show_time" id="show_time">
                            <span class="text-sm text-red-500">{{$errors->book->first('show_time')}}</span>
                        </div>
                        <div class="flex flex-col mb-4">
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest" for="seat_number">Number of Seats</label>
                            <input class="border py-2 px-3 text-grey-darkest" type="number" name="seat_number" id="seat_number">
                            <span class="text-sm text-red-500">{{$errors->book->first('seat_number')}}</span>
                        </div>
                        <div>
                            <input  class="block transition duration-700 ease-in-out bg-green-200 hover:bg-blue-300  transform hover:-translate-y-1 hover:scale-110 p-2 mt-5 uppercase mx-auto rounded text-gray-700" type="submit" value="Add Movie">
                        </div>
                    </form>
                    
                </div>
            </div>
        </div>
</x-app-layout>

resources/views/admin.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Dashboard') }}
        </h2>
    </x-slot>

    @if(Session::has('alert'))
        <div class="pl-4 bg-red-300">
            {{Session::get('alert')}}
        </div>
    @else
        <div class="pl-4 bg-indigo-300">
            {{Session::get('status')}}
        </div>
    @endif
    <div class="pt-12 ">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8 mb-10">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg mb-10">
                <div class="p-6 bg-white border-b border-gray-200">
                    You are an Admin.
                    <div class="text-right text-lg text-green-700">
                        <a href="{{url('dashboard/mail')}}">Get Report</a>
                    </div>
                </div>
            </div>

            <div class=" overflow-hidden shadow-sm sm:rounded-lg ">
                <div class="grid grid-cols-2 gap-5">
                    @foreach($movies as $movie)
                        <div class="w-full h-full bg-white rounded-md shadow-lg  px-2 py-4 ">
                            <div class="block text-center py-4 m-auto uppercase">
                                <b> {{$movie->title}}</b> 
                            </div> 
                            <div> {{round(($movie->total_seats_booked / ($movie->total_seats_booked+$movie->available_seats))*100)}}% Booking
                                <div class="h-3 relative max-w-xl rounded-full overflow-hidden">
                                    <div class="absolute bg-gray-200 w-full h-full"> </div>
                                        <div class="absolute bg-gradient-to-r bg-green-200 hover:bg-blue-300  h-full" style="width:{{round(($movie->total_seats_booked / ($movie->total_seats_booked+$movie->available_seats))*100)}}%"></div>
                                   
                                </div>
                            </div>

                        </div>
                
                    @endforeach
                </div>
            </div>

        </div> 
    </div>
</x-app-layout>

resources/views/book.blade.php
<x-app-layout>
    <x-slot name="header">
        <div class="flex">
            <x-ticket-logo class="block h-10 w-auto fill-current" />
            <h2 class=" font-semibold text-xl mt-2 ml-3 text-gray-800 leading-tight">
                {{ __('Movie Booking') }}
            </h2>
        </div>
    </x-slot>
    @if(Session::has('errors'))
    <div class="border-red-600 bg-red-200 ">
        {{$errors->book->first()}}
    </div>
    @endif

 
    <div class="py-8">
        <div class="flex items-center max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="overflow-hidden shadow-sm sm:rounded-lg md:max-w-md md:mx-auto">
                <div class="p-6 border-b border-gray-200">
                    <form class="mb-4 p-10 bg-white shadow-lg " method="post" action="{{url('dashboard/book')}}">
                        {{csrf_field()}}
                        <input type="text" value="{{$moviess->id}}" name="movieid" hidden>
                        <input type="text" value="{{Auth::user()->id}}"name="userid" hidden>
                    <div class="mb-2 uppercase font-bold text-lg text-grey-darkest text-center">{{$moviess->title}}</div>
                    <div class="grid grid-row-1 gap-5">
                        <div class="grid grid-cols-2 gap-2 mb-4">                    
                            <label class="mb-2 uppercase font-bold text-md text-grey-darker" for="seats-available">Available Seats</label>
                            <input class="border py-2 px-3 text-grey-darkest" type="text" value="{{$moviess->available_seats}}" readonly>
                        </div>

                        <div class="grid grid-cols-2 mb-4">
                            <label class="mb-2 uppercase font-bold text-md text-grey-darker" for="seatsbooked">Seats:</label>
                            <input class="border py-2 px-3 text-grey-darkest" type="number" max="{{$moviess->available_seats}}" placeholder="How many seats?" min=1 name="seatsbooked">
                        </div>
                    </div>
                    <div>
                    <input class=" block transition duration-700 ease-in-out bg-green-200 hover:bg-blue-300  transform hover:-translate-y-1 hover:scale-101 text-gray-700 uppercase text-md mx-auto p-4 rounded mt-5" type="submit" name="submit-booking" value="Book My Ticket!" id=""> 
                    </div>
                    </form>
                    
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/cancel.blade.php
<x-app-layout>
    <x-slot name="header">
        <div class="flex">
            <x-cancel-logo class="block h-10 w-auto fill-current" />
            <h2 class="font-semibold text-xl mt-2 ml-3 text-gray-800 leading-tight">
                {{ __('Cancel') }}
            </h2>
        </div>

    </x-slot>

    <div class="py-5 ">
        <div class=" items-center">
            <div class="w-full rounded shadow-lg p-8 m-4 md:max-w-6xl md:mx-auto">
                <div class="grid grid-cols-3 gap-4 ">
                        @foreach ($userHistory as $item)
                            <div class="shadow-lg my-5 bg-gray-100">
                                <form  method="post" action="{{url('dashboard/cancel')}}">
                                    {{csrf_field()}}
                                    <div class="pl-5">
                                        <div class="my-2 text-center uppercase font-bold text-lg text-grey-darkest">{{$item->title}}</div>
                                        <input type="text" name="movie_id" value="{{$item->movie_id}}" hidden>
                                        <div class="text-center ">
                                            <label for="seatsbooked">Seats Booked:</label>
                                            <input class="bg-gray-100 text-center" id="seatsbooked" name="seats_booked" value="{{$item->seats_booked}}">
                                        </div>
                                        <div><button class=" block transition duration-700 ease-in-out bg-green-200 hover:bg-blue-300  transform hover:-translate-y-1 hover:scale-110 text-gray-700 p-2 mt-5 uppercase mx-auto rounded" type="submit" name="booking_id" value="{{$item->id}}">Cancel</button></div><br><br>
                                    </div>
                                </form>
                            </div>
                        @endforeach
                        
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/dashboard.blade.php
<x-app-layout>
    <x-slot name="header">
        <div class="flex">
            <x-dashboard-logo class="block h-10 w-auto fill-current" />
            <h2 class="font-semibold text-xl mt-2 ml-3 text-gray-800 leading-tight">
                {{ __('Dashboard') }}
            </h2>
        </div>
    </x-slot>
        {{-- <div class="border-red-600 bg-red-200">
            {{$errors->book->first()}}
        </div> --}}
   
        <div class="pl-4 bg-green-200 border-green-800">
            {{Session::get('book') ?? ''}}
        </div>
        <div class="pl-4 bg-yellow-200 border-yellow-500">
            {{Session::get('cancel') ?? ''}}
        </div>

    

    <div class="py-5">
        <div class=" shadow-lg max-w-7xl mx-auto sm:px-6 lg:px-8 p-10">
            <div class="grid grid-cols-2 gap-5">
                @foreach($movies as $movie)
                            <div class="w-full h-full bg-white rounded-md shadow-lg  px-2 py-4 ">
                                <form class="movies" method="get" action="{{url('dashboard/book')}}">
                                    <div class="">
                                        <div class="block text-center py-4 m-auto uppercase">
                                            <b> {{$movie->title}}</b> 
                                        </div> 
                                        <div> <b>About The Movie</b>
                                            <div class="movie-description">
                                                {{$movie->movie_description}}
                                            </div>   
                                        </div>
                                        <div>
                                            <div class="my-5"><b>Show time</b> 
                                                <div class="">{{$movie->show_date}}</div>
                                                <div>{{$movie->show}}</div>
                                            </div>
                                            @if ($movie->available_seats==0)
                                                <button type="submit" class="block mx-auto mt-5 bg-gray-400 text-white rounded p-2 uppercase" name="id" value="{{$movie->id}}" disabled>Sold OUT !</button>
                                            @else
                                                <button type="submit" class=" block transition duration-700 ease-in-out bg-green-200 hover:bg-blue-300 transform hover:-translate-y-1 hover:scale-110 p-2 mt-5 uppercase mx-auto rounded text-gray-700" name="id" value="{{$movie->id}}">Book This Show</button> 
                                                <div class="text-xs pt-3 text-right text-red-600">
                                                    @if($movie->available_seats<10)
                                                        Hurry, Only a few more seats left!
                                                    @endif
                                                </div>
                                            @endif

                                        </div> 
                                    </div>
                                </form>
                            </div>
            
                @endforeach
            </div>
        </div>
    </div>
    
</x-app-layout>

resources/views/editmovie.blade.php
<x-app-layout>
    <x-slot name="header">
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Edit/Delete Movie') }}
        </h2>
    </x-slot>
    @if(Session::has('errors'))
    <div class="pl-4 border-red-600 bg-red-200 ">
        Whoops! You missed some fields.
    </div>
    @endif
    <div class="py-8">
        <div class="flex items-center w-full ">
            <div class="w-full bg-green-100 rounded shadow-lg p-8 m-3 md:max-w-md md:mx-auto">
                <div class="block w-full  text-grey-darkest mb-6">
                    <form class="mb-4"  method="post" action="{{url('/dashboard/editmovie')}}" id="editform">
                        {{csrf_field()}}
                        <div class="flex flex-col mb-4">
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest"  for="movie_options">Movie Options</label>
                            <select class="border py-2 px-3 text-grey-darkest" name="movieoptions" id="movie_options">
                                <option disabled selected>select movie</option>
                                @foreach($movieOptions as $movie)
                                    <option value="{{$movie->id}}">{{$movie->id}}.{{$movie->title}}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="flex flex-col mb-4">               
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest"  for="movie_title">Movie title: </label>
                            <input class="border py-2 px-3 text-grey-darkest" type="text" name="movie_title" id="movie_title">
                            <span class="text-sm text-red-500">{{$errors->book->first('movie_title')}}</span>

                        </div>
                        <div class="flex flex-col mb-4">
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest"  for="movie_description">Description</label>
                            <textarea class="border py-2 px-3 text-grey-darkest h-24" type="text" name="movie_description" id="movie_description"></textarea>
                            <span class="text-sm text-red-500">{{$errors->book->first('movie_description')}}</span>

                            </div>
                        <div class="flex flex-col mb-4">                    
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest"  for="id">ID: </label>
                            <input class="border py-2 px-3 text-grey-darkest" type="text" readonly name="id" id="id">
                        </div>
                        <div class="flex flex-col mb-4">                    
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest"  for="show_time">Show Time</label>
                            <input class="border py-2 px-3 text-grey-darkest" type="datetime-local" name="show_time" id="show_time">
                            <span class="text-sm text-red-500">{{$errors->book->first('show_time')}}</span>
                        </div>
                        <div class="flex flex-col mb-4">                    
                            <label class="mb-2 uppercase font-bold text-lg text-grey-darkest"  for="seat_number">Number of Seats</label>
                            <input class="border py-2 px-3 text-grey-darkest" type="number" name="seat_number" id="seat_number" >
                            <span class="text-sm text-red-500">{{$errors->book->first('seat_number')}}</span>

                        </div>
                        <div class=" m-auto w-max">                    
                            <input  class=" transition duration-700 ease-in-out bg-green-200 hover:bg-blue-300  transform hover:-translate-y-1 hover:scale-110 p-2 mt-5 mr-4 uppercase mx-auto rounded text-gray-700" type="submit" value="Edit Movie" name="edit">
                            <input  class=" transition duration-700 ease-in-out bg-green-200 hover:bg-blue-300  transform hover:-translate-y-1 hover:scale-110 p-2 mt-5 uppercase mx-auto rounded text-gray-700" type="submit" value="Delete Movie" name="delete">
                        </div>
                    </form>
                    
                </div>
            </div>
        </div>
    </div>
<script>
    $("#movie_options").change(function() {
        var title = document.getElementById('movie_title');
        var description = document.getElementById('movie_description');
        var id = document.getElementById('id');
        var showTime = document.getElementById('show_time');
        var seatNumber = document.getElementById('seat_number');
$.ajax({
    url: 'editmovie/' + $(this).val(),
    type: 'get',
    data: {},
    success: function(data) {
            title.value = data.info[0]["title"];
            description.value = data.info[0]["movie_description"];
            id.value = data.info[0]["id"];
            showTime.value = data.info[0]["show_time"].split(" ").join('T');
            seatNumber.value = data.info[0]["available_seats"];
            console.log(data.info[0]["show_time"].split(" ").join(''))
        

    },
    error: function(jqXHR, textStatus, errorThrown) {}
});
});
</script>
</x-app-layout> 

resources/views/mail.blade.php
<h3 class="aligncenter" style="font-family: 'Helvetica Neue',Helvetica,Arial,'Lucida Grande',sans-serif; box-sizing: border-box; font-size: 20px; color: #000; line-height: 1.2em; font-weight: 400; text-align: center; margin: 40px 0 0;" align="center">{{ $details['title'] }}</h3>

<table >
    <thead>
        <tr >
            <th style="padding: 3px">Movie ID</th>
            <th style="padding: 3px">Movie Title</th>
            <th style="padding: 3px">Show Time</th>
            <th style="padding: 3px">Seats Booked</th>
            <th style="padding: 3px">Available Seats</th>
        </tr>
    </thead>
    <tbody>
        @foreach ($details['body'] as $item)
            <tr>
                <td align="center" style="padding: 3px">{{$item->id}}</td>
                <td align="center" style="padding: 3px">{{$item->title}}</td>
                <td align="center" style="padding: 3px">{{$item->show_time}}</td>
                <td align="center" style="padding: 3px">{{$item->total_seats_booked}}</td>
                <td align="center" style="padding: 3px">{{$item->available_seats}}</td>
            </tr>
    
        @endforeach
    </tbody>
</table>

<p>Thank You</p>

resources/views/purchase.blade.php
<x-app-layout>
    <x-slot name="header">
        <div class="flex">
            <x-purchase-logo class="block h-10 w-auto fill-current" />
            <h2 class=" font-semibold text-xl mt-2 ml-3 text-gray-800 leading-tight">
                {{ __('My Purchases') }}
            </h2>
        </div>
    </x-slot>

    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="  overflow-hidden shadow-lg">
                <div class="p-6  ">
                    <table class="w-full shadow-lg bg-white">
                        <thead>
                            <tr class="h-16">
                                <th class="bg-green-100 border text-xl">Movie</th>
                                <th class="bg-green-100 border text-xl">Seats Booked</th>
                                <th class="bg-green-100 border text-xl">Booked On</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ($userHistory as $item)
                                <tr>
                                    <td class="border text-lg">{{$item->title}}</td>
                                    <td class="border text-center">{{$item->seats_booked}}</td>
                                    <td class="border text-center">{{$item->booking_date}}</td>
                                </tr>
                        
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/ticketmail.blade.php
<h3 class="aligncenter" style="font-family: 'Helvetica Neue',Helvetica,Arial,'Lucida Grande',sans-serif; box-sizing: border-box; font-size: 20px; color: #000; line-height: 1.2em; font-weight: 400; text-align: center; margin: 40px 0 0;" align="center">{{ $details['title'] }}</h3>
<div style="font-size: 15px">
<p>Hello Dear Customer,</p><br>
<p>You have succesfully booked a show! The details of your ticket are provided below</p><br>
<p><b>Movie : </b>{{$details['body'][1]->title}}</p><br>
<p><b>Show Time : </b>{{$details['body'][1]->show_time}}</p><br>
<p><b> Seats Booked : </b>{{$details['body'][0]->seats_booked}}</p><br>
<br>
<hr>
<p>We hope you you have a great time<br> Thank you,<br>The Cinema</p>
</div>

resources/views/viewmovie.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('View Movie') }}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="overflow-hidden shadow-lg sm:rounded-lg">
                <div class="p-6 ">

                    <table class="w-full bg-white shadow-md">
                        <thead>
                            <tr class="h-16">
                                <th class="bg-green-100 border text-xl">Movie</th>
                                <th class="bg-green-100 border text-xl">Tickets Booked</th>
                                <th class="bg-green-100 border text-xl">Seats Available</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ($tickets as $item)
                                <tr>
                                    <td class="border text-lg">{{$item->title}}</td>
                                    <td class="border text-center">{{$item->total_seats_booked}}</td>
                                    <td class="border text-center">{{$item->available_seats}}</td>
                                </tr>
                            
                            @endforeach
                        </tbody>
                </table>
            </div>
        </div>
    </div>
</x-app-layout>